src/config/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from django.views.generic.base import TemplateView

from accounts.views import send_email
from config import settings

urlpatterns = [
    path("admin/", admin.site.urls),
    path("__debug__/", include("debug_toolbar.urls")),
    path("accounts/", include("accounts.urls")),
    path("accounts/", include("django.contrib.auth.urls")),
    path("", TemplateView.as_view(template_name="index.html"), name="index"),
    path("", include("base_app.urls")),
    path("", include("students.urls")),
    path("", include("teachers.urls")),
    path("", include("groups.urls")),
    path("send-test-email/", send_email, name="send_email"),
    path("oauth/", include("social_django.urls", namespace="social")),
    path("accounts/", include("django.contrib.auth.urls")),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

# handler404 = "students.views.custom_404"
# handler404 = "Custom404View.as_view()"

src/students/urls.py
from django.urls import path

import students
from .views import (
    IndexView,
    AllStudents,
    CreateStudentView,
    UpdateStudentView,
    DeleteStudent,
    ResumeUploadView,
    search_history,
)

app_name = "students"

urlpatterns = [
    path("", IndexView.as_view(), name="index"),
    path("students/", AllStudents.as_view(), name="students"),
    path("students/create/", CreateStudentView.as_view(), name="create_student"),
    path(
        "students/update/<uuid:uuid>/",
        UpdateStudentView.as_view(),
        name="update_student",
    ),
    path(
        "students/delete/<uuid:uuid>/", DeleteStudent.as_view(), name="delete_student"
    ),
    path("students/testing/", students.views.testing, name="testing"),
    path("students/resume_list/", ResumeUploadView.as_view(), name="upload"),
    path("search-history/", search_history, name="search_history"),
]

src/students/models.py
import datetime
import random
from uuid import uuid4

from django.db import models

# from django.utils.translation import gettext_lazy as _
from faker import Faker

from base_app.models import Person


class Student(Person):
    uuid = models.UUIDField(
        default=uuid4, primary_key=True, editable=False, unique=True, db_index=True
    )

    group = models.ForeignKey(
        to="groups.Group",
        null=True,
        related_name="all_students_in_group",
        on_delete=models.CASCADE,
    )
    avatar = models.ImageField(
        upload_to="static/students/avatars",
        default=None,
        blank=True,
        null=True,
    )

    resume_file = models.FileField(
        upload_to="resumes/", default=None, blank=True, null=True
    )

    class Meta:
        verbose_name = "Student"
        verbose_name_plural = "Students"
        ordering = ("last_name",)

    def age(self):
        return datetime.datetime.now().year - self.birth_date.year

    def __str__(self):
        return f"{self.first_name} {self.last_name}, email: {self.email}"

    @classmethod
    def generate_instances(cls, count):
        fake = Faker()
        for _ in range(count):
            cls.objects.create(
                last_name=fake.last_name(),
                first_name=fake.first_name(),
                email=fake.email(),
                birth_date=fake.date_time_between(start_date="-30y", end_date="-18y"),
                group_name=random.choice(["Python", "Java", "QA"]),
            )


# class UploadedFile(models.Model):
#     resume_file = models.FileField(upload_to="resumes/")
#     avatar = models.ImageField(upload_to="students/avatars")


#     uploaded_at = models.DateTimeField(auto_now_add=True)

src/students/forms.py
from django.core.exceptions import ValidationError
from django.forms import ModelForm

from students.models import Student


class StudentForm(ModelForm):
    class Meta:
        model = Student
        fields = ("resume_file", "first_name", "last_name", "email", "group_name")

    @staticmethod
    def normalize_text(text: str):
        return text.strip().capitalize()

    def clean_email(self):
        email = self.cleaned_data["email"]

        if "@yandex" in email.lower():
            raise ValidationError("Yandex is forbidden!")
        return email

    def clean_last_name(self):
        return self.normalize_text(self.cleaned_data["last_name"])

    def clean_first_name(self):
        return self.normalize_text(self.cleaned_data["first_name"])

    def clean(self):
        cleaned_data = super().clean()

        first_name = cleaned_data["first_name"]
        last_name = cleaned_data["last_name"]

        if first_name == last_name:
            raise ValidationError("First_name and last_name cant be equal!")
        return cleaned_data


# class UploadFileForm(forms.Form):
#     class Meta:
#         model = Student
#         fields = ("resume_file",)


# class UploadFileForm(forms.ModelForm):
#     resume_file = forms.FileField()

src/students/views.py
import datetime
import os

from django.contrib.auth.mixins import LoginRequiredMixin
from django.db.models import Q
from django.http import HttpRequest, Http404, HttpResponse
from django.shortcuts import render
from django.urls import reverse_lazy
from django.views.generic import (
    CreateView,
    UpdateView,
    TemplateView,
    ListView,
    DeleteView,
)

from config import settings
from groups.models import Group
from students.forms import StudentForm
from .models import Student


class IndexView(TemplateView):
    template_name = "index.html"
    extra_context = {"key": "guys", "site_name": "LMS"}

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context["my_name"] = "Oleg"
        return context


class CreateStudentView(LoginRequiredMixin, CreateView):
    template_name = "students/create.html"
    form_class = StudentForm
    # model = Student
    # fields = ("first_name", "last_name", "email", "group_name")
    success_url = reverse_lazy("students:create_student")


class AllStudents(LoginRequiredMixin, ListView):
    model = Student
    template_name = "students/list.html"
    context_object_name = "students"


def get_students(request: HttpRequest, params):
    students = Student.objects.all()
    search_fields = ["first_name", "last_name", "email"]

    for name, value in params.items():
        if name == "search_fields":
            request.session[f"search_text_{datetime.datetime.now()}"] = value
            or_filter = Q()
            for field in search_fields:
                or_filter |= Q(**{f"{field}__iconains": value})
            students = students.filter(or_filter)
        else:
            students = students.filter(**{name: value})
    return render(
        request, template_name="students/list.html", context={"students": students}
    )


def search_history(request: HttpRequest):
    log_info = {}
    for key, value in request.session.items():
        if "search_text_" in key:
            log_info.update({key: value})
    return render(
        request, template_name="search_history.html", context={"search_logs": log_info}
    )


class UpdateStudentView(LoginRequiredMixin, UpdateView):
    template_name = "students/update.html"
    # context_object_name = "students"
    form_class = StudentForm
    pk_url_kwarg = "uuid"
    queryset = Student.objects.all()
    success_url = reverse_lazy("students:students")


class DeleteStudent(LoginRequiredMixin, DeleteView):
    template_name = "students/delete.html"
    context_object_name = "students"
    form_class = StudentForm
    pk_url_kwarg = "uuid"
    queryset = Student.objects.filter()
    success_url = reverse_lazy("students:students")


class ResumeUploadView(ListView):
    model = Student
    template_name = "students/resume_list.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        resumes = []
        for student in self.object_list:
            if student.resume_file:
                resumes.append(student.resume_file)
        context["resumes"] = resumes
        return context


def download_resume(request, resume):
    file_path = os.path.join(settings.MEDIA_ROOT, resume.resume.name)
    if os.path.exists(file_path):
        with open(file_path, "rb") as fh:
            response = HttpResponse(fh.read(), content_type="application/vnd.ms-excel")
            response["Content-Disposition"] = "inline; filename=" + os.path.basename(
                file_path
            )
            return response
    raise Http404


def testing(request: HttpRequest):
    # student_1 = Student.objects.get(uuid="1f27bdc9b7cc43dcaf55d49e885eaf76")
    # student_2 = Student.objects.filter(uuid="ea8099ce52664b508b51d53ec7450c86")
    # print(f"{student_1=}")
    # print(f"{student_2=}")
    # print(f"{student_1.group.group_name}")
    # target_group = Group.objects.first()
    # data_to_save = []
    # for _ in range(10):
    #     new_student = Student()
    #     new_student.first_name = "first_name"
    #     new_student.last_name = "last_name"
    #     new_student.email = "email@email.com"
    #     new_student.group = target_group
    #     data_to_save.append(new_student)
    #
    # Student.objects.bulk_create(data_to_save)

    target_group = Group.objects.filter(group_name__in=["Java"]).first()
    # students = target_group.all_students_in_group.all()
    return render(request, template_name="testing.html", context={"data": target_group})


# class ResumeUploadView(View):
#     template_name = "students/upload.html"
#
#     def get(self, request):
#         form = UploadFileForm()
#         return render(request, self.template_name, {"form": form})
#
#     def post(self, request):
#         form = UploadFileForm(request.POST, request.FILES)
#         if form.is_valid():
#             form.save()
#             return redirect(
#                 "resume_list"
#             )  # Redirect to a view that displays all resumes
#         return render(request, self.template_name, {"form": form})

src/templates/students/confirm_delete.html
{% extends 'index.html' %}

{% block content %}
    <h1>Confirm Student Deletion</h1>
    <form action="{% url 'student_delete' pk=student.uuid %}" method="post">
        {% csrf_token %}
        <input type="hidden" name="csrfmiddlewaretoken" value="{{ csrf_token }}">
        <p>Are you sure you want to delete this student?</p>
        <p>Student ID: {{ student.uuid }}</p>
        <p>Student Name: {{ student.first_name }} {{ student.last_name }}</p>
        <p>Email: {{ student.email }}</p>
        <button type="submit">Confirm Deletion</button>
    </form>
{% endblock content %}

src/templates/students/create.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method='POST' enctype="multipart/form-data" style="width: 25em; margin: auto">
        {% csrf_token %}
        {{ form|crispy }}
        <button type="submit" class="btn btn-success" value="Create">Create student</button>
    </form>
{% endblock content %}

src/templates/students/delete.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method='POST' style="width: 25em; margin: auto">
        {% csrf_token %}
        {{ form|crispy }}
        <button type="submit" class="btn btn-success" value="delete">Delete student</button>
    </form>
{% endblock content %}

src/templates/students/download.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method='POST' style="width: 25em; margin: auto">
        {% csrf_token %}
        {{ form|crispy }}
        <a href="{% url 'download' student.resume_file %}">Download Resume</a>

    </form>
{% endblock content %}

src/templates/students/list.html
{% extends "index.html" %}

{% block content %}

    <table class="table table-dark table-striped">
        <thead>
        <tr>
            <th scope="col">#</th>
            <th scope="col">First name</th>
            <th scope="col">Last name</th>
            <th scope="col">Email</th>
            <th scope="col">Name of group</th>
            <th scope="col">Birth date</th>
            <th scope="col">Age</th>
            <th scope="col">Update</th>
            <th scope="col">Delete</th>
            <th scope="col">Resume</th>

        </tr>
        </thead>
        <tbody>

        {% for student in students %}
            <tr>
                <th scope="row">{{ student.resume_file }}</th>
                <td>{{ student.first_name }}</td>
                <td>{{ student.last_name }}</td>
                <td>{{ student.email }}</td>
                <td>{{ student.group_name }}</td>
                <td>{{ student.birth_date|default:"Unknown" }}</td>
                {% if student.birth_date %}
                    <td>{{ student.age }}</td>
                {% else %}
                    <td>Unknown age</td>
                {% endif %}
                <th><a type="button" class="btn btn-warning" href="{% url 'students:update_student' student.uuid %}"
                >Update</a></th>
                <th><a type="button" class="btn btn-warning" href="{% url 'students:delete_student' student.uuid %}"
                >Delete</a></th>
                <th><a type="button" class="btn btn-warning" href="{% url 'students:upload' %}">Resume</a></th>
            </tr>
        {% endfor %}

        </tbody>
    </table>
{% endblock content %}

src/templates/students/resume_list.html
{% extends 'index.html' %}

{% block content %}
    {% for resume in resumes %}
        <a href="{{ resume.resume_file.url }}">{{ resume.resume_file }}</a><br>
    {% endfor %}

{% endblock %}

src/templates/students/update.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method='POST' style="width: 25em; margin: auto">
        {% csrf_token %}
        {{ form|crispy }}
        <button type="submit" class="btn btn-success" value="Update">Update student</button>
    </form>
{% endblock content %}

src/templates/students/upload.html
{% extends 'index.html' %}

{% block content %}
    <form method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit">Upload Resume</button>
    </form>

{% endblock %}